// LICENSE:  LGPL2.1
// Copyright (c) 2002 Tomoya Tokairin

#ifndef __OGGDEC_H__
#define __OGGDEC_H__

#include <windows.h>

typedef void (CALLBACK *OGGINPUT_MSG_PROC)(DWORD msg,DWORD dwParam1,DWORD dwParam2);

#ifdef OGGDEC_EXPORTS
#define	EXPORT __declspec(dllexport) WINAPI
#else
#define	EXPORT WINAPI
#endif

typedef struct
{
	char szTrackName[256];	// track
	char szArtistName[256];	// artist
	char szAlbumName[256];	// album
	char szData[256];		// date
	char szRes1[256];
	char szRes2[256];
	char szRes3[256];
	char szRes4[256];

	DWORD channels;						
	DWORD bitRate;	// bps		
	DWORD samplingRate;					
	DWORD totalSec;	// time (msec)
	DWORD dwRes1;
	DWORD dwRes2;
	DWORD dwRes3;
	DWORD dwRes4;

}OGGINPUTINFO,*LPOGGINPUTINFO;


BOOL EXPORT oggdec_init();
BOOL EXPORT oggdec_free();

BOOL EXPORT oggdec_open(LPCSTR lpszFileName, LPOGGINPUTINFO pInfo);
void EXPORT oggdec_setWaveOutDeviceId(unsigned int uId);
BOOL EXPORT oggdec_callback(OGGINPUT_MSG_PROC pProc);
BOOL EXPORT oggdec_close();

BOOL EXPORT oggdec_play();
BOOL EXPORT oggdec_stop();
BOOL EXPORT oggdec_seek(DWORD dwMsec);
BOOL EXPORT oggdec_pause();
BOOL EXPORT oggdec_restart();

DWORD EXPORT oggdec_getWave(short* pWaveL, short* pWaveR, DWORD dwMaxSize);
DWORD EXPORT oggdec_getState(LPDWORD lpdwMsec);
long EXPORT oggdec_getVersion(char* lpszVer);

#endif // #ifndef __OGGDEC_H__