// LICENSE:  LGPL2.1
// Copyright (c) 2002 Tomoya Tokairin

#include <windows.h>
#include <stdio.h>
#include <mmsystem.h>
#include "common.h"

// Xe[^X
#define ID_PREPARE 0
#define ID_OPEN 1
#define ID_CLOSEWAVE 3

#define WAVEHDR_BUFNUM 2  // wb_̐

// O[oϐ
HWAVEOUT HWaveOut = NULL;  // ĐfoCX̃nh
WAVEHDR WaveHdr[WAVEHDR_BUFNUM]; // wave wb_̃obt@
WORD WCurWaveHdr = 0;  // ݎgpĂ wave wb_̔ԍ
WORD PlayStatus; // ݂̃Xe[^X
HANDLE HSemaphore; // Z}tH



//-------------------------------------------------------------------
// WAVEtH[}bgZbg֐
void SetWaveFmt(LPWAVEFORMATEX lpWaveFmt,WORD waveChn,
				DWORD waveRate,	WORD waveBit)
{
	
	lpWaveFmt->wFormatTag = (WORD)0x0001; // PCM tH[}bg
	lpWaveFmt->nChannels = waveChn;  // `l
	lpWaveFmt->nSamplesPerSec = waveRate; // [g
	lpWaveFmt->nAvgBytesPerSec = (DWORD)(waveRate*waveChn*waveBit/8); // byte/sec
	lpWaveFmt->nBlockAlign = (WORD)(waveChn*waveBit/8); // byte/block
	lpWaveFmt->wBitsPerSample = waveBit; // rbg
	lpWaveFmt->cbSize = (WORD)0; // g񖳂 
}



//-------------------------------------------------------------------
// wave wb_̃obt@Zbg֐
BOOL SetWaveHdr(LPWAVEHDR lpWaveHdr, LONG nHdrNumber,DWORD dwWaveBlockByte)
{
	LONG i;
	LPBYTE lpWaveData;
	
	// obt@m
	lpWaveData =(LPBYTE)GlobalAlloc(GPTR,sizeof(BYTE)*dwWaveBlockByte*nHdrNumber);
	
	if(lpWaveData == NULL){
#ifdef _DEBUG
		fprintf(stderr, "̊mۂɎs܂B");
#endif
		return FALSE;
	}
	
	// wave wb_[ݒ
	for(i=0;i<nHdrNumber;i++){
		memset(&lpWaveHdr[i], 0, sizeof(WAVEHDR));
		lpWaveHdr[i].lpData  = (LPSTR)lpWaveData+dwWaveBlockByte*i;	// f[^i[̈m
		lpWaveHdr[i].dwBufferLength = dwWaveBlockByte; // f[^TCY
	}
	
	return TRUE;
}



//-------------------------------------------------------------------
// wave wb_̃obt@폜֐
BOOL DelWaveHdr(LPWAVEHDR lpWaveHdr)
{
	
	if(lpWaveHdr[0].lpData != NULL){
		if(GlobalFree(lpWaveHdr[0].lpData)!=NULL){
#ifdef _DEBUG
			fprintf(stderr, "̊JɎs܂B");
#endif
			return FALSE;
		}
		else lpWaveHdr[0].lpData=NULL;
	}
	
	return TRUE;
}



//-------------------------------------------------------------------
// R[obN֐
VOID CALLBACK MyWaveOutProc(HWAVEOUT hWaveOut,UINT msg,DWORD inst,DWORD dwP1,DWORD dwP2)
{
	LPWAVEHDR lpWaveHdr; 
	
	switch (msg) {
		
	case WOM_OPEN: // WAVE foCXI[v
		
		PlayStatus = ID_OPEN;
		
		break;
		

	case WOM_DONE: // 1 obt@̍ĐI
		
		if(PlayStatus == ID_OPEN){
			
			// wb_̃AhX擾
			lpWaveHdr = (LPWAVEHDR)dwP1;
			
			// ̃obt@gpɂ
			lpWaveHdr->dwUser = 0;
		}
		
		break;
		
	case WOM_CLOSE: // WAVE foCXN[Y
		
		PlayStatus = ID_CLOSEWAVE;
		
		break;
		
	default:
        break;
    }
}



//-------------------------------------------------------------------
// foCXI[v֐
BOOL OpenWaveDevice(UINT uDeviceID,WAVEFORMATEX waveFmt,DWORD dwWaveBlockByte)
{
	int i;
	
	if(HWaveOut != NULL) return FALSE;
	
	if(uDeviceID == -1) uDeviceID = WAVE_MAPPER;

	// obt@m
	if(!SetWaveHdr(WaveHdr,WAVEHDR_BUFNUM,dwWaveBlockByte)) return FALSE;
	
	// foCXI[u
	PlayStatus = ID_PREPARE;
	if(waveOutOpen(&HWaveOut, uDeviceID,
		&waveFmt, (DWORD)MyWaveOutProc, 0, CALLBACK_FUNCTION ) != MMSYSERR_NOERROR ){
		
#ifdef _DEBUG
		fprintf(stderr, "TEhfoCX(ID = %d)̃I[vɎs܂B\ñvZX WAVE foCXgpĂ\܂B",uDeviceID);
#endif		
		DelWaveHdr(WaveHdr);
		return FALSE;
	} 
	
	// I[v܂Œ~
	i=0;
	while(PlayStatus != ID_OPEN && i<50){
		Sleep(50);
		i++; 
	}

#ifdef _DEBUG
	fprintf(stderr, "TEhfoCX(ID = %d)I[v܂\n",uDeviceID);
#endif
	
	// obt@̏
	for(i=0;i<WAVEHDR_BUFNUM;i++)
		waveOutPrepareHeader(HWaveOut,&WaveHdr[i],sizeof(WAVEHDR));

	// Z}tH
	HSemaphore = CreateSemaphore(NULL,1,1,NULL);

	return TRUE;
}



//-------------------------------------------------------------------
// Đ
BOOL PlayWave(BYTE* lpBuffer,DWORD dwWriteByte,LPDWORD lpdwThreadStat,LPBOOL lpbPause){

	if(dwWriteByte == 0) return TRUE;
	if(HWaveOut == NULL || PlayStatus != ID_OPEN) return FALSE;
	if(*lpdwThreadStat != ID_THREAD_ON) return FALSE;

	if(WaitForSingleObject(HSemaphore,50) == WAIT_TIMEOUT) return FALSE;
	
	// obt@gp\ɂȂ܂ł܂
	while(WaveHdr[WCurWaveHdr].dwUser){
		// rōĐȊȌԂɂȂ邩|[YԂɂȂً}Eo
		if(*lpdwThreadStat != ID_THREAD_ON || *lpbPause) goto L_ERR; 
		Sleep(10);
	}

	// f[^Rs[
	CopyMemory(WaveHdr[WCurWaveHdr].lpData,lpBuffer,dwWriteByte);
			
	//foCXɃf[^𑗂
	WaveHdr[WCurWaveHdr].dwBufferLength = dwWriteByte;
	if(dwWriteByte!=0) waveOutWrite(HWaveOut,&WaveHdr[WCurWaveHdr],sizeof(WAVEHDR));
	WaveHdr[WCurWaveHdr].dwUser = 1;
			
	// ̃obt@
	WCurWaveHdr = (WCurWaveHdr+1)&(WAVEHDR_BUFNUM-1);

	ReleaseSemaphore(HSemaphore,1,NULL);

	return TRUE;

L_ERR:

	ReleaseSemaphore(HSemaphore,1,NULL);

	return FALSE;

}

	
//-------------------------------------------------------------------
// N[Y
BOOL CloseWaveDevice(BOOL bForceStop){

	int i;
	BOOL bRet = TRUE;
	
	if(HWaveOut == NULL) return FALSE;

	WaitForSingleObject(HSemaphore,INFINITE);
	
	//obt@̍ĐI܂ł܂
	if(!bForceStop){
		for(i=0;i<WAVEHDR_BUFNUM;i++){
			while(WaveHdr[i].dwUser) Sleep(10);
		}
	}
	
	// Đ~
	waveOutReset(HWaveOut);
	
	// obt@̌n
	for(i=0;i<WAVEHDR_BUFNUM;i++){
		waveOutUnprepareHeader(HWaveOut,&WaveHdr[i],sizeof(WAVEHDR));
		WaveHdr[WCurWaveHdr].dwUser = 1;
	}

	// foCXN[Y
	if(waveOutClose(HWaveOut)!=MMSYSERR_NOERROR){
#ifdef _DEBUG
		fprintf(stderr, "\n\nTEhfoCX̃N[YɎs܂");
#endif
		bRet = FALSE;
	}
	else{
		// N[Y܂Œ~
		i=0;
		while(PlayStatus != ID_CLOSEWAVE && i<50){
			Sleep(50);
			i++;
		}
		if(i==50){
#ifdef _DEBUG
			fprintf(stderr, "\n\nTEhfoCX̃N[YɎs܂");
#endif
			bRet = FALSE;
		}
#ifdef _DEBUG
		else fprintf(stderr, "\n\nTEhfoCXN[Y܂");
#endif

		HWaveOut = NULL;
	}
	
	// obt@J
	DelWaveHdr(WaveHdr);

	// Z}tHJ
	CloseHandle(HSemaphore);

	return bRet;
}


BOOL ResetWave(){

	if(HWaveOut == NULL) return TRUE;

	waveOutReset(HWaveOut);

	return TRUE;
}
